#include "StdAfx.h"
#include ".\clearcanvasgl.h"
#using <mscorlib.dll>

using namespace IDVR::Tools::OpenGLTools;
using namespace System::Drawing;

/*
This is the standard constructor.
All member variables of this new instance will be set to zero/null.
*/
ClearCanvasGL::ClearCanvasGL(void)
{
	this->m_CanvasBackColor = new float __gc[3];
}

/*
This function overwrites the base init funtion of the class OpenGLCode.
It contains the actual initialization code in OpenGL and also performs the code.
*/
void ClearCanvasGL::Init(void)
{
	glClearColor(this->m_CanvasBackColor[0], this->m_CanvasBackColor[1], this->m_CanvasBackColor[2], 0.0);
}

/*
This function overwrites the base draw funtion of the class OpenGLCode.
It contains the actual drawing code in OpenGL and also performs the code.
*/
void ClearCanvasGL::Draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
}

//Sets a new background color for the canvas.
void ClearCanvasGL::set_CanvasBackColor(Color n_CanvasBackColor)
{
	this->m_CanvasBackColor[0] = (float)n_CanvasBackColor.get_R() / 255.0f;
	this->m_CanvasBackColor[1] = (float)n_CanvasBackColor.get_G() / 255.0f;
	this->m_CanvasBackColor[2] = (float)n_CanvasBackColor.get_B() / 255.0f;
}