#include "StdAfx.h"
#include ".\DvrCompositingModelSW.h"
#using <mscorlib.dll>

using namespace IDVR::VolumeRenderer::SWVolumeRenderer::CompositingModels;

//Standard constructor.
DvrCompositingModelSW::DvrCompositingModelSW(void)
{
	this->m_Intensity = new float __gc[3];
	this->m_Opacity = 0.0f;
	this->m_BackgroundOpacity = 1.0f;
}

//Standrad destructor.
DvrCompositingModelSW::~DvrCompositingModelSW(void)
{
	this->m_Intensity = NULL;
}

//Blends the final intensity and opacity values of a given raysample.
void DvrCompositingModelSW::doCompositing(RaySample* n_RaySample)
{
	float sampeColor __gc[] = n_RaySample->get_Color();

	/*intensity_OUT[RED]   = this->m_Intensity[RED]   + (1.0f - opacity_IN) * sampeColor[RED]   * n_RaySample->get_Opacity();
	intensity_OUT[GREEN] = this->m_Intensity[GREEN] + (1.0f - opacity_IN) * sampeColor[GREEN] * n_RaySample->get_Opacity();
	intensity_OUT[BLUE]  = this->m_Intensity[BLUE]  + (1.0f - opacity_IN) * sampeColor[BLUE]  * n_RaySample->get_Opacity();
*/
	this->m_Intensity[RED]   += ((1.0f - this->m_Opacity) * sampeColor[RED]   * n_RaySample->get_Opacity());
	this->m_Intensity[GREEN] += ((1.0f - this->m_Opacity) * sampeColor[GREEN] * n_RaySample->get_Opacity());
	this->m_Intensity[BLUE]  += ((1.0f - this->m_Opacity) * sampeColor[BLUE]  * n_RaySample->get_Opacity());

	this->m_Opacity += ((1.0f - this->m_Opacity) *  n_RaySample->get_Opacity());

	this->m_BackgroundOpacity *= (1.0f - this->m_Opacity);

	/*if (intensity_OUT[RED]   > 1.0f) intensity_OUT[RED] = 1.0f;
	if (intensity_OUT[GREEN] > 1.0f) intensity_OUT[GREEN] = 1.0f;
	if (intensity_OUT[BLUE]  > 1.0f) intensity_OUT[BLUE] = 1.0f;*/

	if (this->m_Intensity[RED]   > 1.0f) this->m_Intensity[RED] = 1.0f;
	if (this->m_Intensity[GREEN] > 1.0f) this->m_Intensity[GREEN] = 1.0f;
	if (this->m_Intensity[BLUE]  > 1.0f) this->m_Intensity[BLUE] = 1.0f;

	/*this->m_Intensity[RED] = intensity_OUT[RED];
	this->m_Intensity[GREEN] = intensity_OUT[GREEN];
	this->m_Intensity[BLUE] = intensity_OUT[BLUE];*/
}

//Blends the final pixelcolor with the given background color.
void DvrCompositingModelSW::doCompositingBackground(float n_BackColor __gc[])
{
	this->m_Intensity[RED]   += this->m_BackgroundOpacity * n_BackColor[RED];
	this->m_Intensity[GREEN] += this->m_BackgroundOpacity * n_BackColor[GREEN];
	this->m_Intensity[BLUE]  += this->m_BackgroundOpacity * n_BackColor[BLUE];

	if (this->m_Intensity[RED]   > 1.0f) this->m_Intensity[RED]   = 1.0f;
	if (this->m_Intensity[GREEN] > 1.0f) this->m_Intensity[GREEN] = 1.0f;
	if (this->m_Intensity[BLUE]  > 1.0f) this->m_Intensity[BLUE]  = 1.0f;

	this->m_Opacity += this->m_BackgroundOpacity;
}

//Resets the values of the composition model.
void DvrCompositingModelSW::resetValues(void)
{
	this->m_Intensity = new float __gc[3];
	this->m_Opacity = 0.0f;
	this->m_BackgroundOpacity = 1.0f;
}

//Sets the intensity array.
void DvrCompositingModelSW::set_Intensity(float n_Intensity __gc[])
{
	this->m_Intensity = n_Intensity;
}

//Sets the opacity value.
void DvrCompositingModelSW::set_Opacity(float n_Opacity)
{
	this->m_Opacity = n_Opacity;
}

//Returns the intensity array.
float DvrCompositingModelSW::get_Intensity(void) __gc[]
{
	return this->m_Intensity;
}

//Returns the opacity value.
float DvrCompositingModelSW::get_Opacity(void)
{
	return this->m_Opacity;
}