#pragma once

namespace IDVR {
namespace VolumeRenderer {
namespace RenderPrimitives {

/**<B>Class for the footprint element datastructue.</B>

Namespace: IDVR::VolumeRenderer::RenderPrimitives

This class provides the footprint element datastructure. Each footprint element has an objectID, an importance
and a distance.

@see Footprint - the Footprint datastructure
@author <i>Christopher Thurnher</i>
@version 1.0
@date 02-18-2005
*/

public __gc class FootprintElement : public System::Object
{

private:

	short m_ObjectID; /**< The objectID of the footprint element. */
	short m_Importance; /**< The importance of the footprint element. */
	double m_Distance; /**< The distance of the footprint element. */

public:

	/**
	Standard construktor.
	*/
	FootprintElement(void);
	/**
	Construktor.
	*/
	FootprintElement(unsigned short n_ObjectID, short n_Importance, double n_Distance);

	/**
	Sets the objectID of the footprint element.
	@param n_ObjectID the objectID of the footprint element.
	*/
	void setObjectID(unsigned short n_ObjectID);
	/**
	Sets the importance of the footprint element.
	@param n_Importance the importance of the footprint element.
	*/
	void setImportance(short n_Importance);
	/**
	Sets the distance of the footprint element.
	@param n_Distance the distance of the footprint element.
	*/
	void setDistance(double n_Distance);

	/**
	Returns the objectID of the footprint element.
	@return The objectID of the footprint element.
	*/
	unsigned short getObjectID(void);
	/**
	Returns the importance of the footprint element.
	@return The importance of the footprint element.
	*/
	short getImportance(void);
	/**
	Returns the distance of the footprint element.
	@return The distance of the footprint element.
	*/
	double getDistance(void);

};
}
}
}