#pragma once

#include "stdafx.h"

namespace IDVR {
namespace VolumeRenderer {
namespace HWVolumeRenderer {

using namespace System;
using namespace System::Collections;

public __gc class GLSLShaderLoader
{
private:
	
	GLhandleARB m_MipFragObject, m_PhongDVRFragObject, m_ContourFragObject, m_ToneFragObject, 
				m_MipProgrammObject, m_PhongProgrammObject, m_ContourProgrammObject, m_ToneProgrammObject;
	String *m_LogFilename;

	void printInfoLog(GLhandleARB n_Object);
	GLint getUniformLocation(GLhandleARB n_ProgramObject, const GLcharARB *n_ParameterName);
	char* readShaderSource(String *n_Filename);
	bool printOpenGLError(char *n_Filename, int n_Line);

public:

	static const unsigned char PHONG_DVR_SHADER = 0, MIPSHADER = 1, CONTOURSHADER = 2, TONESHADER = 3;

	GLSLShaderLoader(String *n_LogFilename);
	void loadGLSLShaderModel(unsigned char n_ShaderType, String *n_Filename);
};

}
}
}