#pragma once

#include ".\RaySample.h"

#using <mscorlib.dll>

namespace IDVR {
namespace Interfaces {

using namespace IDVR::VolumeRenderer::RenderPrimitives;
using namespace System::Collections;

/*
Interface for the IDVRModulationModel.

namespace: IDVR::Interfaces

This interface Modulates a raysample with its (see IIDVRModulationModel::doModulation) method. This method is called by a IDVRCompoitingMoel.
*/

public __gc __interface IIDVRModulationModel
{
	//Modulates the color and opacity values of a given raysample.
	RaySample* doModulation(RaySample *n_RaySample, Hashtable *n_LevelsOfSparseness) = 0;
};
}
}

/*! \interface IDVR::Interfaces::IIDVRModulationModel
	\brief <B>Interface for the IDVRModulationModel.</B>

	namespace: IDVR::Interfaces

	This interface Modulates a raysample with its (see IIDVRModulationModel::doModulation) method. This method is called by a IDVRCompoitingMoel.

	@see IDVR::VolumeRenderer::SWVolumeRenderer::IDVRModulationModels::IDVRColAndOpModulatorSW - the color and opacity modulator.
	@author <i>Christopher Thurnher</i>
	@version 1.0
	@date 02-18-2005

	<hr>
	<b>Public member function:</b><br><br><ul>
	<li><b>RaySample* doModulation(RaySample *n_RaySample, Hashtable *n_LevelsOfSparseness)</b><br><br>
	 Modulates the color and opacity values of a given raysample.</li><br><br>
   </ul>
 */