#pragma once

#using <mscorlib.dll>

namespace IDVR {
namespace Interfaces {

using namespace System;

public __gc __interface IOpenGLCanvas
{
	void drawImage(unsigned char n_FramBuffer __gc[]) = 0;
};
}
}

/*! \interface IDVR::Interfaces::IOpenGLCanvas
	\brief <B>Interface for the drawing of the calculated results on the canvas.</B>

	namespace: IDVR::Interfaces

	For using different drawing types in the application this interface provides the standard interface
	for the drawing function.

	@author <i>Bernhard Pflugfelder</i>
	@version 1.0
	@date 02-20-2005

	<hr>
	<b>Public member function:</b><br><br><ul>
	<li><b>void drawImage(unsigned char n_FramBuffer __gc[])</b><br><br>
	 Draws the claculated results of the raycaster onto the canvas.<br><br>
	 \param n_FramBuffer contains the final color values (RGB).</li><br><br>
   </ul>
 */