#include "StdAfx.h"
#include ".\MipShadingModelSW.h"
#using <mscorlib.dll>

#include "DataLoader.h"

using namespace IDVR::Volume;
using namespace IDVR::VolumeRenderer::SWVolumeRenderer::ShadingModels;

//Standard constructor.
MipShadingModelSW::MipShadingModelSW(void)
{
	this->m_DensityScope = DataLoader::DensityScope;
	this->m_BaseColor = new float __gc[3];
}

//Constructor.
MipShadingModelSW::MipShadingModelSW(unsigned short n_DensityScope, Color n_Col)
{
	this->m_DensityScope = n_DensityScope;
	this->m_BaseColor = new float __gc[3];

	this->m_BaseColor[RED] = (float)n_Col.get_R() / 255.0f;
	this->m_BaseColor[GREEN] = (float)n_Col.get_G() / 255.0f;
	this->m_BaseColor[BLUE] = (float)n_Col.get_B() / 255.0f;
}

//Calculates the Color value for a given raysample.
RaySample* MipShadingModelSW::doShading(RaySample* n_RaySample)
{
	float temp_Value = (float)n_RaySample->get_Opacity();
	float temp_Color __gc[] = new float __gc[3];
	
	temp_Color[RED] = temp_Value * this->m_BaseColor[RED];
	temp_Color[GREEN] = temp_Value * this->m_BaseColor[GREEN];
	temp_Color[BLUE] = temp_Value * this->m_BaseColor[BLUE];

	n_RaySample->set_Color(temp_Color);

	return n_RaySample;
}

//Returns the current color as Color object.
Color MipShadingModelSW::get_Col(void)
{
	return Color::FromArgb(Convert::ToInt32(Math::Round(this->m_BaseColor[RED] * 255.0)), 
		                   Convert::ToInt32(Math::Round(this->m_BaseColor[GREEN] * 255.0)), 
						   Convert::ToInt32(Math::Round(this->m_BaseColor[BLUE] * 255.0)));
}